/* Canale.java */

import java.util.Vector;

/**
 * @author Fosco
 * 
 * This class realizes the channel
 */
public class Channel {

  private Vector subscribers = new Vector();

  public synchronized void addSubscriber(Subscriber s) {
    // if the subscriber is not registered, add it to the list
    if (!subscribers.contains(s))
      subscribers.add(s);
  }


  public synchronized void removeSubscriber(Subscriber s) {
    // if the subscriber exists, remove it from the list
    if (subscribers.contains(s))
      subscribers.removeElement(s);
  }

  /**
   * Public method to be used by the Editor for the publication of events.
   *  
   */
  public synchronized void put(String msg) {
    if (subscribers.isEmpty())
      return;
    else
      for (int i = 0; i < subscribers.size(); i++) {
	    Subscriber subscriberIth = (Subscriber) subscribers
	         .elementAt(i);
         subscriberIth.push(msg);
	  }
  }

 }